<script setup lang="ts">
import {
  computed,
  defineProps,
  onMounted,
  ref,
  withDefaults,
} from 'vue'
import {
  useStore,
} from 'vuex'
import GitApiCall from '@/api/gitApi'
import ConsoleLogViewer from '@/components/gitlab/pipeline/common/ConsoleLogViewer.vue'
import JobSetupFormComponent from '@/components/gitlab/pipeline/common/JobSetupFormComponent.vue'
import pipelineMixin from '@/components/gitlab/pipeline/common/pipelineMixin' // Importa el mixin

const props = withDefaults(defineProps<{
  job: {
    executions: {
      id: number
    }[]; id: number; status: string
  }
  groupId: number
  project: {
    id: number
  }
  route: string
}>(), {
  route: 'vendors',
})

const emit = defineEmits()

const {
  timeAgo,
  jobLink,
  allowToDownloadArtifacts,
} = pipelineMixin.methods

const getExecutionIds = () => {
  console.log('[JobItem.vue] job executions are : ', props.job.executions)

  return props.job.executions.map(execution => execution.id)
}

const store = useStore()
const items = getExecutionIds()

console.log('[JobItem.vue] items are :', items)

const user = ref(store.state.user)
const isExpanded = ref(false)
const projectId = ref(props.project.id)

const formJobsContent = ref<Record<string,
any>>({})

const chipColor = computed(() => {
  switch (props.job.status) {
    case 'success':
      return 'success'
    case 'failed':
      return 'error'
    case 'running':
      return 'primary'
    case 'pending':
      return 'warning'
    case 'canceled':
      return 'grey-400'
    case 'skipped':
      return 'grey-300'
    case 'manual':
      return 'purple'
    case 'created':
      return 'info'
    case 'preparing':
      return 'amber'
    case 'scheduled':
      return 'cyan'
    case 'waiting_for_resource':
      return 'yellow'
    case 'failed_with_warnings':
      return 'amber'
    default:
      return 'info'
  }
})

const downloadArtifacts = async (id: number, name: string) => {
  const spinning = ref(true)
  const gitApi = new GitApiCall()
  try {
    const response = await gitApi.downloadArtifacts(projectId.value.toString(), id.toString())

    console.log(response)

    const blob = new Blob([response.data], {
      type: 'application/zip',
    })

    const link = document.createElement('a')

    link.href = URL.createObjectURL(blob)
    link.download = `${name}.zip`
    link.click()
    console.log('Download successful!')
  }
  catch (error) {
    console.error('downloadArtifacts: error: ', error)
  }
  finally {
    spinning.value = false
  }
}

const getFormsJobsContent = async () => {
  const git = new GitApiCall()
  try {
    const response = await git.getFileContent(projectId.value.toString(), 'ui%2Fforms%2Fjobs.json/raw?ref=main')

    formJobsContent.value = response.data
    console.log('getFormsJobsContent this.fileContentData: ', formJobsContent)
  }
  catch (error) {
    formJobsContent.value = {}
    console.error('ERROR! getProjects', error)
  }
}

const listOfFormsItems = (stepName: string) => {
  return formJobsContent.value[stepName]
}

onMounted(() => {
  user.value = store.state.user
  projectId.value = props.project.id
  console.log('[onMounted] user set', user)
  console.log('[onMounted] store is', store)
  getFormsJobsContent()
})

const toggleContent = () => {
  isExpanded.value = !isExpanded.value
  emit('expand-toggle', props.job.id)
}

const retryJobAction = async (jobId: number, projectId: number) => {
  const gitApi = new GitApiCall()
  try {
    const response = await gitApi.retryJob(projectId.toString(), jobId.toString())

    console.log('retryJob: ', response.data)
    emit('retry-job')
  }
  catch (error) {
    console.error('Error retrying job', error)
  }
}
</script>

<template>
  <VRow no-gutters>
    <VCol cols="12">
      <VCard class="mb-5">
        <!-- Job Name -->
        <VCardTitle class="d-flex align-items-center">
          <h6 class="mb-1">
            {{ job.name }}
          </h6>
          <!-- to be set if card is expanded -->
          <VRow v-if="isExpanded">
            <VSpacer />
            <VCol>
              <VChip
                :color="chipColor"
                size="small"
                variant="outlined"
              >
                <small class="text-muted">{{ job.status }}</small>
              </VChip>
            </VCol>
            <VCol>
              <small class="text-muted">Stage: {{ job.stage }}</small>
            </VCol>
            <VCol>
              <small class="text-muted">Duration: {{ job.duration }} seconds</small>
            </VCol>
            <VCol>
              <small class="text-muted">Finished: {{ timeAgo(job.finished_at) }}</small>
            </VCol>
          </VRow>
          <VSpacer />
          <VBtn
            variant="tonal"
            color="info"
            :prepend-icon="isExpanded ? 'tabler-arrows-minimize' : 'tabler-arrows-maximize'"
            size="26"
            @click="toggleContent"
          >
            <!-- v-icon>{{ isExpanded ? 'tabler-arrows-minimize' : 'tabler-arrows-maximize' }}</v-icon -->
            <VTooltip
              bottom
              activator="parent"
              location="bottom"
            >
              {{ isExpanded ? 'Collapse' : 'Expand' }}
            </VTooltip>
          </VBtn>
        </VCardTitle>
        <VCardText>
          <!-- Job Details -->
          <div v-if="!isExpanded">
            <VRow
              no-gutters
              class="mb-0"
            >
              <VChip
                :color="chipColor"
                size="small"
                variant="outlined"
              >
                <small class="text-muted">{{ job.status }}</small>
              </VChip>
            </VRow>
            <VRow no-gutters>
              <VCol no-gutters>
                <small class="text-muted">Stage: {{ job.stage }}</small>
              </VCol>
            </VRow>
            <VRow no-gutters>
              <VCol>
                <small class="text-muted">Duration: {{ job.duration }} seconds</small>
              </VCol>
            </VRow>
            <VRow no-gutters>
              <VCol>
                <small class="text-muted">Finished: {{ timeAgo(job.finished_at) }}</small>
              </VCol>
            </VRow>
          </div>
          <VRow
            v-if="isExpanded"
            class="mt-2 mb-2"
          >
            <!--
              v-container class="expanded-content pa-4" elevation="2">
              <p>This is the expanded content that appears when the card is expanded. Here you can add more details
              about the job.</p>
              </v-container
            -->
            <ConsoleLogViewer
              :job-id="job.id"
              :project-id="projectId"
              style="width: 1000px"
            />
          </VRow>
          <VRow class="mt-4 ml-0">
            <VBtnGroup
              divided
              class="pa-1"
            >
              <!-- Dropdown Button -->
              <VMenu
                offset-y
                location="bottom"
              >
                <template #activator="{ props }">
                  <VBtn
                    variant="outlined"
                    icon
                    v-bind="props"
                    size="34"
                  >
                    <VIcon color="primary">
                      tabler-file-report
                    </VIcon>
                    <VTooltip
                      bottom
                      activator="parent"
                      location="bottom"
                    >
                      Execution report
                    </VTooltip>
                  </VBtn>
                </template>
                <VList>
                  <VListItem
                    v-for="execution in job.executions"
                    :key="execution.id"
                    :to="jobLink(route, groupId, project, execution)"
                  >
                    <VListItemTitle>Execution_report_{{ execution.id }}</VListItemTitle>
                  </VListItem>
                </VList>
              </VMenu>
              <!-- Retry Button  @click="onSelectItem(item)" -->
              <VBtn
                v-if="allowToDownloadArtifacts(user, job)"
                variant="outlined"
                color="primary"
                icon
                size="34"
                @click="downloadArtifacts(job.id, job.name)"
              >
                <VIcon color="primary">
                  tabler-file-download
                </VIcon>
                <VTooltip
                  bottom
                  activator="parent"
                  location="bottom"
                >
                  Download last artefacts
                </VTooltip>
              </VBtn>
              <VBtn
                v-if="['success', 'failed', 'canceled'].includes(job.status)"
                variant="outlined"
                color="primary"
                icon
                size="34"
                @click="retryJobAction(job.id, projectId)"
              >
                <VIcon color="primary">
                  tabler-refresh
                </VIcon>
                <VTooltip
                  bottom
                  activator="parent"
                  location="bottom"
                >
                  Retry job
                </VTooltip>
              </VBtn>
            </VBtnGroup>
          </VRow>
          <VRow
            v-if="['manual'].includes(job.status)"
            class="mt-4"
          >
            <JobSetupFormComponent
              :project-id="projectId"
              :step="job"
              :inputs="listOfFormsItems(job.name)"
            />
          </VRow>
        </VCardText>
      </VCard>
    </VCol>
  </VRow>
</template>

<style scoped>
.expanded-card {
  transition: all 0.3s ease-in-out;
  max-width: calc(100% + 300px);
  /* Adjust as needed */
}

.expanded-content {
  right: 0;
  top: 0;
  max-width: 1200px;
  /* Adjust as needed */
  background-color: #f5f5f5;
}
</style>
